VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPurchaseOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3D3D1A8D01A4"
Option Base 0
Option Explicit

Const MODULE_NAME As String = "cPurchaseOrder"

Const PRINTFLAG_REPRINT As String = "R"

Const PURCHASE_ORDER_FILECODE As String = "PO"
Const PRM_EDIPREFIX As Long = 210
Const PRM_SH_SUPP_NO As Long = 222

Implements IBo
Implements ISysBo

Private m_oSession As Session
'##ModelId=3D3FCA0602DA
Private mKey As Long

'##ModelId=3D3D1ADD02D0
Private mOrderNumber As String

'##ModelId=3D3D57B403AC
Private mSupplierNo As String

'##ModelId=3D3D1AE503C0
Private mOrderDate As Date

'##ModelId=3D3D57C5001E
Private mDueDate As Date

'##ModelId=3D3FCA5800F0
Private mReleaseNumber As String

'##ModelId=3D3FCA600280
Private mRaisedBy As String

'##ModelId=3D3FCA6A0172
Private mSource As String

'##ModelId=3D3FCA7302F8
Private mHOOrderNumber As String

'##ModelId=3D3FCA7E001E
Private mSOQNumber As String

'##ModelId=3D3FCA8602F8
Private mNoOfCartons As Long

'##ModelId=3D3FCA90024E
Private mQuantityOnOrder As Long

'##ModelId=3D3D1AEE0136
Private mValue As Double

'##ModelId=3D3FCABF02D0
Private mPrintFlag As String

'##ModelId=3D3FCAC8026C
Private mNoOfRePrints As Long

'##ModelId=3D3FCAD301EA
Private mReceiptNumber As String

'##ModelId=3D3FCAD901E0
Private mPricingNumber As String

'##ModelId=3D3FCAE40168
Private mReceivedAll As Boolean

'##ModelId=3D3FCAF203CA
Private mReceivedPart As Boolean

'##ModelId=3D3FCDD601AE
Private mDeletedByMaint As Boolean

'##ModelId=3D3FCDF30104
Private mCommed As Boolean

'##ModelId=3D3FCE0903B6
Private mCommNumber As String

'##ModelId=3D3D1AEB0190
Private mEDIStatus As Long

'##ModelId=3DA2F77703B6
Private mNoLines As Long

'##ModelId=3E633F73000A
Private mConsolidationLines As cPurchaseConsLine

'##ModelId=4077C7A301ED
Private mCarraigeValue As Double

'##ModelId=4077CE140049
Private mWeight As Long

'##ModelId=4077CE19015F
Private mCompletedDate As Date

'##ModelId=4077CE2303C6
Private mCancelledBy As String

'##ModelId=4077ED7F0206
Private mTimeCreated As String

'##ModelId=4077ED860261
Private mHOReceivedDate As Date

'##ModelId=4077ED980202
Private mHORecNotifyDate As Date

'##ModelId=4077EDA603C5
Private mHORecNotifyTime As String

'##ModelId=4077EE0A0383
Private mHORecNotifyErrDone As Boolean

'##ModelId=4077EE1601FA
Private mHOSuppConfDate As Date

'##ModelId=4077EE2E023A
Private mHOSuppConfNotifyDate As Date

'##ModelId=4077EE4502C9
Private mHOSuppConfNotifyTime As String

'##ModelId=4077EE5B0235
Private mHOSuppConfErrDone As Boolean

'##ModelId=4077EE7600B7
Private mHOSuppDelDate As Date

'##ModelId=4077EE8701B6
Private mHOSuppDelNotifyDate As Date

'##ModelId=4077EE930268
Private mHOSuppDelNotifyTime As String

'##ModelId=4077EE9D0077
Private mHOSuppDelErrDone As Boolean

'##ModelId=4077EEB803A1
Private mEDIConfDeliveryDate As Date

Private mGetAllLines As Boolean

Private mGetOSLines As Boolean

Private moRowSel As IRowSelector

Private mcolLines As Collection 'local collection of Purchase Order Lines

Private mcolConsolLines As Collection 'local collection of Consolidated Purchase Order Lines

Private blnParkOrder As Boolean 'flag used by Park Order to leave order number blank

Private mNarrative As String

Private moLoadRow As IRowSelector

Public Enum enDespatchType
    DespatchTypeSnailMail = 0             ' Default value
    DespatchTypeFax = 1
    DespatchTypeEmail = 2
End Enum

Public Enum enDespatchStatus
    DespatchStatusNotDespatched = 0             ' Default value
    DespatchStatusInTransit = 1
    DespatchStatusUnconfirmed = 2
    DespatchStatusConfirmed = 3
End Enum

Private m_eDespatchStatus As enDespatchStatus

Private m_oSupplier As cSupplier

Dim mintNarrStatus  As Integer

Const NOT_LOADED As Long = -1
Const LOADED As Long = 0
Const EDITED As Long = 1


'##ModelId=4077C756023C
Public Function RecordReceivedAtHO(ReceivedDate As Date) As Boolean

Dim oRow As IRow
    
    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    mHOReceivedDate = ReceivedDate
    mHORecNotifyDate = Date
    mHORecNotifyTime = Format$(Time, "HHNNSS")
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOReceivedDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HORecNotifyDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HORecNotifyTime))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing
    
    RecordReceivedAtHO = True
    
End Function

'##ModelId=4077C76A0281
Public Function RecordReceivedBySupplier(ReceivedDate As Date, DeliveryDate As Date) As Boolean
    
Dim oRow As IRow
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    mEDIConfDeliveryDate = DeliveryDate
    mHOSuppConfDate = ReceivedDate
    mHOSuppConfNotifyDate = Date
    mHOSuppConfNotifyTime = Format$(Time, "HHMMSS")
    Call oRow.Add(GetField(FID_PURCHASEORDER_EDIConfDeliveryDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOSuppConfDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOSuppConfNotifyDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOSuppConfNotifyTime))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing
    
    RecordReceivedBySupplier = True
    
End Function

'##ModelId=4077C776003A
Public Function RecordDelInfoProcessed(ProcessedDate As Date) As Boolean

Dim oRow As IRow
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    mHOSuppDelDate = ProcessedDate
    mHOSuppDelNotifyDate = Date
    mHOSuppDelNotifyTime = Format$(Time, "HHNNSS")
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOSuppDelDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOSuppDelNotifyDate))
    Call oRow.Add(GetField(FID_PURCHASEORDER_HOSuppDelNotifyTime))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing
    
    RecordDelInfoProcessed = True
    
End Function

'##ModelId=4077F3AB00FA
Public Function RecordEDIQuantity(PartCode As String, Quantity As Long) As Boolean

Dim lngItemNo As Long
Dim blnFound  As Boolean
Dim oLines    As cPurchase_Wickes.cPurchaseLine
    
    blnFound = False
    If (mcolLines Is Nothing) Then Call RetrieveLines(True) 'ensure line items have been loaded
    'Step through lines and locagte matching Part Code to update quantity
    For lngItemNo = 1 To mcolLines.Count Step 1
        If mcolLines(lngItemNo).PartCode = PartCode Then
            Set oLines = mcolLines(lngItemNo)
            blnFound = oLines.UpdateConfirmedQuantity(Quantity)
            Exit For
        End If
    Next lngItemNo
    
    RecordEDIQuantity = blnFound

End Function

'##ModelId=40780AE302D8
Public Property Get EDIConfDeliveryDate() As Date
   Let EDIConfDeliveryDate = mEDIConfDeliveryDate
End Property

'##ModelId=40780AE301A1
Public Property Get HOSuppDelErrDone() As Boolean
   Let HOSuppDelErrDone = mHOSuppDelErrDone
End Property

'##ModelId=40780AE30061
Public Property Get HOSuppDelNotifyTime() As String
   Let HOSuppDelNotifyTime = mHOSuppDelNotifyTime
End Property

'##ModelId=40780AE200CE
Public Property Get HOSuppDelNotifyDate() As Date
   Let HOSuppDelNotifyDate = mHOSuppDelNotifyDate
End Property

'##ModelId=40780AE10389
Public Property Get HOSuppDelDate() As Date
   Let HOSuppDelDate = mHOSuppDelDate
End Property

'##ModelId=40780AE1025D
Public Property Get HOSuppConfErrDone() As Boolean
   Let HOSuppConfErrDone = mHOSuppConfErrDone
End Property

'##ModelId=40780AE1013A
Public Property Get HOSuppConfNotifyTime() As String
   Let HOSuppConfNotifyTime = mHOSuppConfNotifyTime
End Property


'##ModelId=40780AE0020B
Public Property Get HOSuppConfNotifyDate() As Date
   Let HOSuppConfNotifyDate = mHOSuppConfNotifyDate
End Property

'##ModelId=40780AE000E9
Public Property Get HOSuppConfDate() As Date
   Let HOSuppConfDate = mHOSuppConfDate
End Property

'##ModelId=40780ADF03C2
Public Property Get HORecNotifyErrDone() As Boolean
   Let HORecNotifyErrDone = mHORecNotifyErrDone
End Property

'##ModelId=40780ADF02AA
Public Property Get HORecNotifyTime() As String
   Let HORecNotifyTime = mHORecNotifyTime
End Property

'##ModelId=40780ADE0385
Public Property Get HORecNotifyDate() As Date
   Let HORecNotifyDate = mHORecNotifyDate
End Property

'##ModelId=40780ADE0276
Public Property Get HOReceivedDate() As Date
   Let HOReceivedDate = mHOReceivedDate
End Property

'##ModelId=40780ADE0168
Public Property Get TimeCreated() As String
   Let TimeCreated = mTimeCreated
End Property

'##ModelId=40780ADA0158
Public Property Get NoLines() As Long
   Let NoLines = mNoLines
End Property

'##ModelId=40780AD90374
Public Property Let NoLines(ByVal Value As Long)
    Let mNoLines = Value
End Property


'##ModelId=
Public Property Let Narrative(ByVal Value As String)
    mNarrative = Value
    mintNarrStatus = EDITED
End Property

Public Property Get Narrative() As String

Dim oPONarr As cPurHdrNarrative

    If mintNarrStatus = NOT_LOADED Then
        Set oPONarr = m_oSession.Database.CreateBusinessObject(CLASSID_PURHDRNARRATIVE)
        Call oPONarr.IBo_AddLoadFilter(CMP_EQUAL, FID_PURHDRNARRATIVE_OrderID, mKey)
        Call oPONarr.IBo_AddLoadFilter(CMP_EQUAL, FID_PURHDRNARRATIVE_StoreNumber, m_oSession.CurrentEnterprise.IEnterprise_StoreNumber)
        Call oPONarr.IBo_Load
        mNarrative = oPONarr.TextLine1
        If LenB(oPONarr.TextLine2) <> 0 Then mNarrative = mNarrative & vbCrLf & oPONarr.TextLine2
        Set oPONarr = Nothing
        mintNarrStatus = LOADED
    End If
    Narrative = mNarrative
    
End Property


'##ModelId=3D3D1AA70078
Public Function AddItem(PartCode As String) As cPurchase_Wickes.cPurchaseLine

Dim oLine As cPurchase_Wickes.cPurchaseLine

    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_PURCHASEORDERLINE)
    oLine.PartCode = PartCode
    oLine.Complete = False
    oLine.PurchaseOrder = Me
    
    If mcolLines Is Nothing Then Set mcolLines = New Collection
    Call mcolLines.Add(oLine)
    Set AddItem = oLine

End Function

'##ModelId=3D3D1AAA02EE
Public Sub DeleteItem()
End Sub

'##ModelId=3D3D4D990122
Public Sub UpdateDeliveryDate(dteDueDate As Date)

Dim oRow As IRow

    mDueDate = dteDueDate
    
    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    Call oRow.Add(GetField(FID_PURCHASEORDER_DueDate))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub
'##ModelId=3DEF322E029E
Public Sub IncrementReleaseNumber()

Dim oRow As IRow

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    mReleaseNumber = Format$(CLng(mReleaseNumber) + 1, "00")
    Call oRow.Add(GetField(FID_PURCHASEORDER_ReleaseNumber))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub

'##ModelId=3D3FC3950398
Public Sub RecordItemDelivered(lLineNo As Long, _
                               dblQuantityRecd As Double, _
                               sDelNoteNo As String, _
                               lDelNoteLineNo As Long, _
                               dblQuantityBackOrder As Double, _
                               dteDelNoteDate As Date)

Dim oLine         As cPurchase_Wickes.cPurchaseLine
Dim lLinePos      As Long
Dim blnCompleted  As Boolean
Dim oRow          As IRow

    'If Order found then get lines for Order
    
    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_PURCHASEORDERLINE)
    If mcolLines Is Nothing Then Call Lines.Count 'force loading of Lines - only when first accessed
    'Locate line to update, on Purchase Order
    For lLinePos = 1 To mcolLines.Count Step 1
        If mcolLines(CLng(lLinePos)).LineNo = lLineNo Then
            Set oLine = mcolLines(CLng(lLinePos))
            Exit For
        End If
    Next lLinePos
    'Update values
    Call oLine.RecordItemDelivered(dblQuantityRecd, dblQuantityBackOrder, sDelNoteNo, lDelNoteLineNo, dteDelNoteDate)
    Set oLine = Nothing
    
    'Check if all lines have been completed, if so mark Purchase Order as complete
    blnCompleted = True
    For lLinePos = 1 To mcolLines.Count Step 1
        If mcolLines(CLng(lLinePos)).Complete = False Then
            blnCompleted = False
            Exit For
        End If
    Next lLinePos
    mReceivedAll = blnCompleted
    mReceivedPart = True
    If mReceivedAll = True Then mCompletedDate = Now()
    
    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    Call oRow.Add(GetField(FID_PURCHASEORDER_ReceivedAll))
    Call oRow.Add(GetField(FID_PURCHASEORDER_ReceivedPart))
    If mReceivedAll = True Then Call oRow.Add(GetField(FID_PURCHASEORDER_CompletedDate))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub

'##ModelId=3D5B742700E6
Public Property Get EDIStatus() As Long
   Let EDIStatus = mEDIStatus
End Property

'##ModelId=40780ADD013F
Public Property Get CompletedDate() As Date
   Let CompletedDate = mCompletedDate
End Property
'##ModelId=40780ADD024D
Public Property Get CancelledBy() As String
   Let CancelledBy = mCancelledBy
End Property
'##ModelId=3D5B742602A8
Public Property Let EDIStatus(ByVal Value As Long)
    Let mEDIStatus = Value
End Property

'##ModelId=3D5B7426015E
Public Property Get CommNumber() As String
   Let CommNumber = mCommNumber
End Property

'##ModelId=3D5B74250320
Public Property Let CommNumber(ByVal Value As String)
    Let mCommNumber = Value
End Property

'##ModelId=40780ADB0330
Public Property Get CarraigeValue() As Currency
   Let CarraigeValue = mCarraigeValue
End Property

'##ModelId=40780ADB0150
Public Property Let CarraigeValue(ByVal Value As Currency)
    Let mCarraigeValue = Value
End Property

'##ModelId=3D5B74240258
Public Property Get Commed() As Boolean
   Let Commed = mCommed
End Property

'##ModelId=3D5B74240032
Public Property Let Commed(ByVal Value As Boolean)
    Let mCommed = Value
End Property

'##ModelId=3D5B742302D0
Public Property Get DeletedByMaint() As Boolean
   Let DeletedByMaint = mDeletedByMaint
End Property

'##ModelId=3D5B742300DC
Public Property Let DeletedByMaint(ByVal Value As Boolean)
    Let mDeletedByMaint = Value
End Property

'##ModelId=3D5B742203B6
Public Property Get ReceivedPart() As Boolean
   Let ReceivedPart = mReceivedPart
End Property

'##ModelId=3D5B742201C2
Public Property Let ReceivedPart(ByVal Value As Boolean)
    Let mReceivedPart = Value
End Property

'##ModelId=3D5B74220078
Public Property Get ReceivedAll() As Boolean
   Let ReceivedAll = mReceivedAll
End Property

'##ModelId=3D5B742102A8
Public Property Let ReceivedAll(ByVal Value As Boolean)
    Let mReceivedAll = Value
End Property

'##ModelId=3D5B7421015E
Public Property Get PricingNumber() As String
   Let PricingNumber = mPricingNumber
End Property

'##ModelId=3D5B74200398
Public Property Let PricingNumber(ByVal Value As String)
    Let mPricingNumber = Value
End Property

'##ModelId=3D5B7420024E
Public Property Get ReceiptNumber() As String
   Let ReceiptNumber = mReceiptNumber
End Property

'##ModelId=3D5B74200096
Public Property Let ReceiptNumber(ByVal Value As String)
    Let mReceiptNumber = Value
End Property

'##ModelId=3D5B741F03A2
Public Property Get NoOfRePrints() As Long
   Let NoOfRePrints = mNoOfRePrints
End Property

'##ModelId=3D5B741F01EA
Public Property Let NoOfRePrints(ByVal Value As Long)
    Let mNoOfRePrints = Value
End Property

'##ModelId=3D5B741F00D2
Public Property Get PrintFlag() As String
   Let PrintFlag = mPrintFlag
End Property

'##ModelId=3D5B741E033E
Public Property Let PrintFlag(ByVal Value As String)
    Let mPrintFlag = Value
End Property

'##ModelId=3D5B741E0226
Public Property Get Value() As Double
   Let Value = mValue
End Property

'##ModelId=3D5B741E003C
Public Property Let Value(ByVal Value As Double)
    Let mValue = Value
End Property

'##ModelId=3D5B741D030C
Public Property Get QuantityOnOrder() As Long
   Let QuantityOnOrder = mQuantityOnOrder
End Property

'##ModelId=3D5B741D01CC
Public Property Let QuantityOnOrder(ByVal Value As Long)
    Let mQuantityOnOrder = Value
End Property

'##ModelId=3D5B741D00B4
Public Property Get NoOfCartons() As Long
   Let NoOfCartons = mNoOfCartons
End Property

'##ModelId=3D5B741C0352
Public Property Let NoOfCartons(ByVal Value As Long)
    Let mNoOfCartons = Value
End Property

'##ModelId=3D5B741C0276
Public Property Get SOQNumber() As String
   Let SOQNumber = mSOQNumber
End Property

'##ModelId=3D5B741C00FA
Public Property Let SOQNumber(ByVal Value As String)
    Let mSOQNumber = Value
End Property

'##ModelId=3D5B741C001E
Public Property Get HOOrderNumber() As String
   Let HOOrderNumber = mHOOrderNumber
End Property

'##ModelId=3D5B741B0280
Public Property Let HOOrderNumber(ByVal Value As String)
    Let mHOOrderNumber = Value
End Property

'##ModelId=3D5B741B01A4
Public Property Get Source() As String
   Let Source = mSource
End Property

'##ModelId=3D5B741B005A
Public Property Let Source(ByVal Value As String)
    Let mSource = Value
End Property

'##ModelId=3D5B741A0366
Public Property Get RaisedBy() As String
   Let RaisedBy = mRaisedBy
End Property

'##ModelId=3D5B741A021C
Public Property Let RaisedBy(ByVal Value As String)
    Let mRaisedBy = Value
End Property

'##ModelId=3D5B741A0140
Public Property Get ReleaseNumber() As String
   Let ReleaseNumber = mReleaseNumber
End Property

'##ModelId=3D5B7419030C
Public Property Get DueDate() As Date
   Let DueDate = mDueDate
End Property

'##ModelId=3D5B741901C2
Public Property Let DueDate(ByVal Value As Date)
    Let mDueDate = Value
End Property

'##ModelId=3D5B74190118
Public Property Get OrderDate() As Date
   Let OrderDate = mOrderDate
End Property

'##ModelId=3D5B7419000A
Public Property Let OrderDate(ByVal Value As Date)
    Let mOrderDate = Value
End Property

'##ModelId=3D5B74180348
Public Property Get SupplierNo() As String
   Let SupplierNo = mSupplierNo
End Property

'##ModelId=40780ADC0237
Public Property Get Weight() As Long
   Let Weight = mWeight
End Property

'##ModelId=40780ADC0057
Public Property Let Weight(ByVal Value As Long)
    Let mWeight = Value
End Property

'##ModelId=3D5B7418026C
Public Property Let SupplierNo(ByVal Value As String)
    Let mSupplierNo = Value
    
    If Not (m_oSupplier Is Nothing) Then

        ' we could simply 'Reset' the supplier object here to initial values,
        ' except the IBo interface does not support a reset() method.  So as
        ' second best, we reset the supplier and do a load() to reset all properties.
        ' We do this in case other objects  still have references to the PO supplier.
        Call m_oSupplier.IBo_AddLoadFilter(CMP_EQUAL, FID_SUPPLIER_SupplierNo, mSupplierNo)
        Call m_oSupplier.IBo_Load
    End If

End Property

'##ModelId=3D5B741801CC
Public Property Get OrderNumber() As String
   Let OrderNumber = mOrderNumber
End Property

'##ModelId=3D5B741800F0
Public Property Let OrderNumber(ByVal Value As String)
    Let mOrderNumber = Value
End Property

'##ModelId=3D5B74180046
Public Property Get Key() As Long
   Let Key = mKey
End Property


'##ModelId=3D5B74170352
Public Property Let Key(ByVal Value As Long)
    Let mKey = Value
End Property

Public Property Get GetAllLines() As Boolean
   Let GetAllLines = mGetAllLines
End Property

'##ModelId=
Public Property Let GetAllLines(ByVal Value As Boolean)
    Let mGetAllLines = Value
End Property

Public Property Get GetOSLines() As Boolean
   Let GetOSLines = mGetOSLines
End Property

'##ModelId=
Public Property Let GetOSLines(ByVal Value As Boolean)
    Let mGetOSLines = Value
End Property

Public Property Get DespatchStatus() As enDespatchStatus
    DespatchStatus = m_eDespatchStatus
End Property
'##ModelId=
Private Property Let DespatchStatus(eValue As enDespatchStatus)
    ' private member
    m_eDespatchStatus = eValue
End Property

Public Property Get Supplier() As cSupplier
    
    If m_oSupplier Is Nothing Then
        If IsEmpty(mSupplierNo) Then
            ' There is no supplier number so return nothing
        Else
            Set m_oSupplier = m_oSession.Database.CreateBusinessObject(CLASSID_SUPPLIER)
            If m_oSupplier Is Nothing Then
                Debug.Assert False
            Else
                m_oSupplier.SupplierNo = mSupplierNo
            End If
        End If
    End If
    Set Supplier = m_oSupplier

End Property


'<CACH>****************************************************************************************
'* Function:  Boolean LoadFromRow()
'**********************************************************************************************
'* Description: Part of the IBo interface called by the DB object to pass in a row of field and
'*              for this object to extract the data and populate the properties of the object.
'**********************************************************************************************
'* Parameters:
'*In/Out:oRow   Object. - collection of fields
'**********************************************************************************************
'* Returns:  Boolean
'**********************************************************************************************
'* History:
'* 15/08/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function LoadFromRow(oRow As IRow) As Boolean

Dim lFieldNo As Integer
Dim oField   As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".LoadFromRow"

    mintNarrStatus = NOT_LOADED
    LoadFromRow = True
    For lFieldNo = 1 To oRow.Count Step 1
        Set oField = oRow.Field(lFieldNo)
        Select Case (oField.ID)
            Case (FID_PURCHASEORDER_Key):              mKey = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_OrderNumber):      mOrderNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_SupplierNo):       mSupplierNo = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_OrderDate):        mOrderDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_DueDate):          mDueDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_ReleaseNumber):    mReleaseNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_RaisedBy):         mRaisedBy = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_Source):           mSource = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOOrderNumber):    mHOOrderNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_SOQNumber):        mSOQNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_NoOfCartons):      mNoOfCartons = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_QuantityOnOrder):  mQuantityOnOrder = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_Value):            mValue = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_PrintFlag):        mPrintFlag = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_NoOfRePrints):     mNoOfRePrints = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_ReceiptNumber):    mReceiptNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_PricingNumber):    mPricingNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_ReceivedAll):      mReceivedAll = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_ReceivedPart):     mReceivedPart = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_DeletedByMaint):   mDeletedByMaint = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_Commed):           mCommed = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_CommNumber):       mCommNumber = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_EDIStatus):        mEDIStatus = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_Weight):           mWeight = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_CancelledBy):      mCancelledBy = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_CompletedDate):    mCompletedDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_CarraigeValue):    mCarraigeValue = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_TimeCreated):      mTimeCreated = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOReceivedDate):   mHOReceivedDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HORecNotifyDate):  mHORecNotifyDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HORecNotifyTime):  mHORecNotifyTime = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HORecNotifyErrDone): mHORecNotifyErrDone = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppConfDate):   mHOSuppConfDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppConfNotifyDate):   mHOSuppConfNotifyDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppConfNotifyTime):   mHOSuppConfNotifyTime = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppConfErrDone): mHOSuppConfErrDone = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppDelDate):     mHOSuppDelDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppDelNotifyDate):    mHOSuppDelNotifyDate = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppDelNotifyTime):    mHOSuppDelNotifyTime = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_HOSuppDelErrDone):       mHOSuppDelErrDone = oField.ValueAsVariant
            Case (FID_PURCHASEORDER_EDIConfDeliveryDate):    mEDIConfDeliveryDate = oField.ValueAsVariant
            Case Else: 'invalid field ID passed in
                LoadFromRow = False
        End Select
    Next lFieldNo

End Function 'LoadFromRow

Private Sub Class_Initialize()

    Call DebugMsg(MODULE_NAME, "Initialise", endlTraceIn)
    m_eDespatchStatus = DespatchStatusNotDespatched

End Sub

Private Function IBo_CreateNew() As IBo

    Set IBo_CreateNew = New cPurchaseOrder

End Function

Public Property Get IBo_DebugString() As String
    
    IBo_DebugString = "Purchase Order " & mKey

End Property

Public Function GetField(lFieldID As Long) As IField

    If CheckIsUnInitialised(m_oSession, IBo_ClassName) Then
        lFieldID = 0
        Exit Function
    End If
    
    Select Case (lFieldID)
        Case (FID_PURCHASEORDER_Key):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mKey
        Case (FID_PURCHASEORDER_OrderNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mOrderNumber
        Case (FID_PURCHASEORDER_SupplierNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierNo
        Case (FID_PURCHASEORDER_OrderDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mOrderDate
        Case (FID_PURCHASEORDER_DueDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDueDate
        Case (FID_PURCHASEORDER_ReleaseNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mReleaseNumber
        Case (FID_PURCHASEORDER_RaisedBy):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mRaisedBy
        Case (FID_PURCHASEORDER_Source):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSource
        Case (FID_PURCHASEORDER_HOOrderNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHOOrderNumber
        Case (FID_PURCHASEORDER_SOQNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSOQNumber
        Case (FID_PURCHASEORDER_NoOfCartons):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoOfCartons
        Case (FID_PURCHASEORDER_QuantityOnOrder):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mQuantityOnOrder
        Case (FID_PURCHASEORDER_Value):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValue
        Case (FID_PURCHASEORDER_PrintFlag):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mPrintFlag
        Case (FID_PURCHASEORDER_NoOfRePrints):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoOfRePrints
        Case (FID_PURCHASEORDER_ReceiptNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mReceiptNumber
        Case (FID_PURCHASEORDER_PricingNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mPricingNumber
        Case (FID_PURCHASEORDER_ReceivedAll):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mReceivedAll
        Case (FID_PURCHASEORDER_ReceivedPart):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mReceivedPart
        Case (FID_PURCHASEORDER_DeletedByMaint):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mDeletedByMaint
        Case (FID_PURCHASEORDER_Commed):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mCommed
        Case (FID_PURCHASEORDER_CommNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCommNumber
        Case (FID_PURCHASEORDER_EDIStatus):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mEDIStatus
        Case (FID_PURCHASEORDER_Weight):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mWeight
        Case (FID_PURCHASEORDER_CompletedDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mCompletedDate
        Case (FID_PURCHASEORDER_CancelledBy):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mCancelledBy
        Case (FID_PURCHASEORDER_CarraigeValue):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mCarraigeValue
        Case (FID_PURCHASEORDER_TimeCreated):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTimeCreated
        Case (FID_PURCHASEORDER_HOReceivedDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mHOReceivedDate
        Case (FID_PURCHASEORDER_HORecNotifyDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mHORecNotifyDate
        Case (FID_PURCHASEORDER_HORecNotifyTime):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHORecNotifyTime
        Case (FID_PURCHASEORDER_HORecNotifyErrDone):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mHORecNotifyErrDone
        Case (FID_PURCHASEORDER_HOSuppConfDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mHOSuppConfDate
        Case (FID_PURCHASEORDER_HOSuppConfNotifyDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mHOSuppConfNotifyDate
        Case (FID_PURCHASEORDER_HOSuppConfNotifyTime):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHOSuppConfNotifyTime
        Case (FID_PURCHASEORDER_HOSuppConfErrDone):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mHOSuppConfErrDone
        Case (FID_PURCHASEORDER_HOSuppDelDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mHOSuppDelDate
        Case (FID_PURCHASEORDER_HOSuppDelNotifyDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mHOSuppDelNotifyDate
        Case (FID_PURCHASEORDER_HOSuppDelNotifyTime):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHOSuppDelNotifyTime
        Case (FID_PURCHASEORDER_HOSuppDelErrDone):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mHOSuppDelErrDone
        Case (FID_PURCHASEORDER_EDIConfDeliveryDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mEDIConfDeliveryDate
    End Select
    
    If Not GetField Is Nothing Then GetField.ID = lFieldID

End Function

Public Function IBo_EndOfStaticFieldId() As Long

    IBo_EndOfStaticFieldId = FID_PURCHASEORDER_END_OF_STATIC

End Function

Public Function IBo_GetField(nFid As Long) As IField

    Set IBo_GetField = GetField(nFid)

End Function

Public Function IBo_GetSelectAllRow() As IRowSelector
    
    Set IBo_GetSelectAllRow = GetSelectAllRow

End Function

Private Function Initialise(oSession As ISession) As cPurchaseOrder
    Set m_oSession = oSession
    Set Initialise = Me
End Function

Public Function IBo_GetAllFieldsAsRow() As IRow
        
    Set IBo_GetAllFieldsAsRow = GetAllFieldsAsRow()

End Function

Private Function IBo_Initialise(oSession As ISession) As IBo
    
    Set IBo_Initialise = Initialise(oSession)

End Function

Public Property Get IBo_ClassId() As Integer

    IBo_ClassId = CLASSID_PURCHASEORDER

End Property

Public Property Get IBo_ClassName() As String

    IBo_ClassName = MODULE_NAME

End Property

Private Function IBo_Interface(Optional eInterfaceType As Long) As IBo
    Set IBo_Interface = Interface(eInterfaceType)
End Function

Public Function Interface(Optional eInterfaceType As Long) As cPurchaseOrder

Dim oBO As IBo

    Select Case (eInterfaceType)
        Case BO_INTERFACE_IBO:
            Set oBO = Me
            Set Interface = oBO
        Case Else:
            Set Interface = Me
    End Select

End Function

Public Function IBo_Load() As Boolean

    IBo_Load = Load

End Function
Private Function Load() As Boolean
    
' Load up all properties from the database
Dim oView       As IView
    
    Load = False
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
'    If nId <> 0 Then Key = nId
    
    If moRowSel Is Nothing Then
        ' Calling load with nothins selected, so we simply select the current key.
        Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
        Call IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDER_Key, mKey)
    End If
    Call moRowSel.Merge(GetSelectAllRow)
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(moRowSel)
    If Not (oView Is Nothing) Then
        If oView.Count >= 1 Then Load = LoadFromRow(oView.Row(1))
    End If

End Function
'##ModelId=3DEF327401AE
Public Function RecordRePrint() As Boolean

Dim oRow As IRow
    
    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    mPrintFlag = PRINTFLAG_REPRINT
    mNoOfRePrints = mNoOfRePrints + 1
    Call oRow.Add(GetField(FID_PURCHASEORDER_PrintFlag))
    Call oRow.Add(GetField(FID_PURCHASEORDER_NoOfRePrints))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing
    
    RecordRePrint = True
    
End Function
'##ModelId=3DEF322802E4
Public Function GetParkedOrder(ByVal SupplierNo As String) As Boolean

Dim blnLoaded As Boolean
    
    'Retrieve any purchase Orders that are parkjed for this supplier
    Call IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDER_OrderNumber, vbNullString)
    Call IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDER_ReleaseNumber, vbNullString)
    Call IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDER_SupplierNo, SupplierNo)
    blnLoaded = IBo_Load
    
    'If no Order then exit
    If blnLoaded = False Then
        GetParkedOrder = False
        Exit Function
    End If
    
    Call RetrieveLines(True)
    
    GetParkedOrder = True

End Function

'##ModelId=3DEF3284023A
Public Sub RetrieveLines(blnAllLines As Boolean)

Dim oLine As cPurchase_Wickes.cPurchaseLine

    'If Order found then get lines for Order
    Set mcolLines = New Collection
    Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_PURCHASEORDERLINE)
    Call oLine.IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDERLINE_PurchaseOrderNo, mKey)
    Call oLine.IBo_AddLoadFilter(CMP_GREATERTHAN, FID_PURCHASEORDERLINE_LineNo, 0)
    If blnAllLines = False Then Call oLine.IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDERLINE_Complete, False)
    Set mcolLines = oLine.IBo_LoadMatches

End Sub
'##ModelId=3DA2F7D500D2
Public Function Lines() As Collection

    If (mcolLines Is Nothing) And (mGetAllLines = True) Then Call RetrieveLines(True)
    If (mcolLines Is Nothing) And (mGetOSLines = True) Then Call RetrieveLines(False)
    Set Lines = mcolLines
    
End Function
Public Function ConsolidationLines() As Collection

Dim oLine As cPurchase_Wickes.cPurchaseConsLine

    If (mcolConsolLines Is Nothing) Then
        'if consolidation lines not loaded then get from database
        Set mcolConsolLines = New Collection
        Set oLine = m_oSession.Database.CreateBusinessObject(CLASSID_PURCHASECONSLINE)
        Call oLine.IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASECONSLINE_PurchaseOrderNumber, mOrderNumber)
        Set mcolConsolLines = oLine.IBo_LoadMatches
    End If
    Set ConsolidationLines = mcolConsolLines
    
End Function
Private Function ISysBo_LoadFromRow(oRow As IRow) As Boolean
    
    Call LoadFromRow(oRow)

End Function

Private Property Get IBo_Version() As String
    
    IBo_Version = App.Major & "." & App.Minor & "." & App.Revision

End Property

Private Function GetSelectAllRow() As IRowSelector
' Returns a CRow object containing one SelectAll field selector for each property.
    
    Set GetSelectAllRow = GetSelectAllRows(CLASSID_PURCHASEORDER, FID_PURCHASEORDER_END_OF_STATIC, m_oSession)

End Function

Public Function IBo_Save() As Boolean

    IBo_Save = Save(SaveTypeAllCases)

End Function

Public Function IBo_SaveIfNew() As Boolean

    If LenB(Me.HOOrderNumber) = 0 Then Me.HOOrderNumber = "000000"
    If LenB(Me.SOQNumber) = 0 Then Me.SOQNumber = "000000"
    If LenB(Me.ReleaseNumber) = 0 Then mReleaseNumber = "00"
    If LenB(Me.CommNumber) = 0 Then Me.CommNumber = "0000"
    If LenB(Me.ReceiptNumber) = 0 Then Me.ReceiptNumber = "000000"
    If LenB(Me.PricingNumber) = 0 Then Me.PricingNumber = "000000"
    Me.Commed = False
    
    IBo_SaveIfNew = Save(SaveTypeIfNew)

End Function

'##ModelId=3DA2F7FD0244
Public Function ParkOrder() As Boolean

    If LenB(Me.HOOrderNumber) = 0 Then Me.HOOrderNumber = "000000"
    If LenB(Me.SOQNumber) = 0 Then Me.SOQNumber = "000000"

    blnParkOrder = True
    If mKey = 0 Then
        ParkOrder = Save(SaveTypeIfNew)
    Else
        ParkOrder = Save(SaveTypeIfExists)
    End If

End Function
Public Function IBo_SaveIfExists() As Boolean

    IBo_SaveIfExists = Save(SaveTypeIfExists)

End Function

Public Function IBo_Delete() As Boolean

    IBo_Delete = Delete

End Function

Public Function IBo_IsValid() As Boolean

    IBo_IsValid = IsValid()

End Function

'##ModelId=3D3D4DC703D4
Public Function CancelOrder() As Boolean

Dim oRow        As IRow
Dim dblOSValue  As Double
Dim dblOSQty    As Double
Dim lngLineNo   As Long
Dim lngCustLine As Long
Dim oPOLine     As cPurchaseLine
Dim oItem       As cInventory
'Dim oCustLine   As cOrderLine
'Dim oCustLines  As Collection
    
On Error GoTo ErrHandler

    'Save updated fields back to Database
    m_oSession.Database.StartTransaction
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    mDeletedByMaint = True
    Call oRow.Add(GetField(FID_PURCHASEORDER_DeletedByMaint))
    mCompletedDate = Now()
    Call oRow.Add(GetField(FID_PURCHASEORDER_CompletedDate))
    mCancelledBy = m_oSession.UserID
    Call oRow.Add(GetField(FID_PURCHASEORDER_CancelledBy))
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)
    
    If mcolLines Is Nothing Then Call RetrieveLines(False)
    For lngLineNo = 1 To mcolLines.Count Step 1
        Set oPOLine = mcolLines(CLng(lngLineNo))
        If oPOLine.OrderQuantity > oPOLine.QuantityReceived Then 'mark line as completed
            'flag line as cancelled
            oPOLine.Complete = True
            Call oPOLine.IBo_SaveIfExists
            'update stock line to indicate not on order
            Set oItem = m_oSession.Database.CreateBusinessObject(CLASSID_INVENTORY)
            dblOSQty = oPOLine.OrderQuantity
            'if quantity received then Qty OS is in Back Order qty instead
            If oPOLine.QuantityReceived > 0 Then dblOSQty = oPOLine.QuantityBackordered
            Call oItem.RecordItemOrderCancel(oPOLine.PartCode, dblOSQty)
            'add line value to Order OS Value
            dblOSValue = dblOSValue + Round((dblOSQty * (oPOLine.OrderPrice / oPOLine.QuantityPerUnit)), 2)
        End If
    Next lngLineNo
    If m_oSupplier Is Nothing Then Set m_oSupplier = m_oSession.Database.CreateBusinessObject(CLASSID_SUPPLIER)
    Call m_oSupplier.CancelPurchaseOrder(mSupplierNo, dblOSValue)
    Set oRow = Nothing
    m_oSession.Database.CommitTransaction
    CancelOrder = True
    
    Exit Function
    
ErrHandler:

    Call Err.Push
    Call m_oSession.Database.RollbackTransaction
    
    Call Err.Pop
    Call Err.Bubble
    
End Function

'##ModelId=3DEF321E02B2
Public Function CreateFile(strPrefixName As String) As Variant

Const PROCEDURE_NAME = MODULE_NAME & ".CreateFile"

Dim strHeader   As String
Dim strTrailer  As String
Dim lngLineNo   As Long
Dim lngNarrNo   As Long
Dim strLine     As String
Dim oFSO        As FileSystemObject
Dim tsOrder     As TextStream
Dim strFilename As String
Dim strSeqNo    As String
Dim oFileNo     As cEDIFileControl
Dim oLine       As cPurchaseLine
Dim strSendSupplier As String 'flag if send file for all suppliers or specific

On Error GoTo Bad_CreateFile

    'taken from parameter list to see if send all
    strSendSupplier = m_oSession.GetParameter(PRM_SH_SUPP_NO)
    'check if supplier specified, then it matches Specified Supplier No, else exit
    Call DebugMsg(MODULE_NAME, "CreateFile", endlDebug, "PRM Supp No='" & strSendSupplier & "' Supp='" & mSupplierNo & "'")
    If (mSupplierNo <> strSendSupplier) And (LenB(Trim$(strSendSupplier)) <> 0) Then
        CreateFile = True
        Exit Function
    End If
    
    strFilename = m_oSession.GetParameter(PRM_TXOUT_FOLDER)
    If LenB(mstrDateFmt) = 0 Then mstrDateFmt = UCase$(m_oSession.GetParameter(PRM_EDI_DATE_FMT))
    
    Set oFileNo = m_oSession.Database.CreateBusinessObject(CLASSID_EDIFILECONTROL)
    
    If LenB(mNarrative) <> 0 Then lngLineNo = 1
    
    'GetEDITextStream(ByRef blnStoreToHeadOffice As Boolean, ByRef strShortCode As String, ByRef strFilePath As String, ByVal strSequenceNo As String) As TextStream
    Set tsOrder = oFileNo.GetEDITextStream(True, PURCHASE_ORDER_FILECODE, strFilename, strSeqNo)
    strHeader = "HR" & Format$(Now(), "DD/MM/YY HH:NN:SS") & " " & strSeqNo & " " & Format$(Lines.Count + 1 + lngLineNo, "000000") & " " & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
    
    Call DebugMsg(MODULE_NAME, "CreateFile", endlDebug, "P ORDER OUT File=" & strSeqNo)
    
    Call tsOrder.WriteLine(strHeader)
    
    Call tsOrder.Write("PH," & mOrderNumber & "," & mSupplierNo & "," & FormatEDIDate(mOrderDate) & "," & FormatEDIDate(mDueDate) & ",")
    Call tsOrder.Write(mReleaseNumber & "," & mRaisedBy & "," & mSource & "," & mHOOrderNumber & "," & mQuantityOnOrder)
    Call tsOrder.Write("," & mValue & "," & mPrintFlag & "," & mNoOfRePrints & ",")
    If mDeletedByMaint = True Then
        Call tsOrder.Write("Y")
    Else
        Call tsOrder.Write("N")
    End If
    Call tsOrder.WriteLine("," & mCarraigeValue)
    
    For lngLineNo = 1 To Lines.Count Step 1
        Set oLine = mcolLines(CLng(lngLineNo))
        strLine = "PL," & mOrderNumber & "," & oLine.LineNo & "," & oLine.PartCode & "," & oLine.SupplierPartCode & ","
        strLine = strLine & oLine.OrderQuantity & "," & oLine.OrderPrice & "," & oLine.CostPrice & ","
        strLine = strLine & FormatEDIDate(oLine.LastOrderDate) & "," & oLine.QuantityPerUnit & "," & oLine.ManufacturerCode
        Call tsOrder.WriteLine(strLine)
    Next lngLineNo
    
    If LenB(mNarrative) <> 0 Then Call tsOrder.WriteLine("PN," & mOrderNumber & "," & Left$(mNarrative, InStr(mNarrative, vbCrLf) - 1) & "," & mID$(mNarrative, InStr(mNarrative, vbCrLf) + 2))
    
    strTrailer = "TR (Not Inc " & IBo_Version & ")"
    Call tsOrder.WriteLine(strTrailer)
    
    Call tsOrder.Close
    
    Call UpdateCommNumber(strSeqNo)
    
    Call oFileNo.MarkAsDone(True, PURCHASE_ORDER_FILECODE, strSeqNo, vbNullString, lngLineNo)
    
    CreateFile = True
    
    Exit Function
    
Bad_CreateFile:

    CreateFile = False
    Call Err.Raise(Err.Number, Err.Source, Err.Description)
    Resume Next
    
End Function

Public Function CreateEDIFile(strPrefixName As String)

Const PROCEDURE_NAME = MODULE_NAME & ".CreateFile"

Dim strHeader   As String
Dim strTrailer  As String
Dim lngLineNo   As Long
Dim strLine     As String
Dim oFSO        As FileSystemObject
Dim tsOrder     As TextStream
Dim strFilename As String
Dim oItem       As cInventory
Dim oStore      As cStore

On Error GoTo Bad_CreateFile

    If LenB(mstrDateFmt) = 0 Then mstrDateFmt = UCase$(m_oSession.GetParameter(PRM_EDI_DATE_FMT))
    
    strFilename = m_oSession.GetParameter(PRM_EDIPATH)
    If (Right$(strFilename, 1) <> "\") Then strFilename = strFilename & "\"
    
    Call DebugMsg(MODULE_NAME, "CreateFile", endlDebug, "P ORDER EDI OUT File=" & strFilename)
    
    strHeader = mOrderNumber & Space$(4) & Format$(mDueDate, "DDMMYYYY")
    'ensure address details loaded
    Set oStore = m_oSession.Database.CreateBusinessObject(CLASSID_STORE)
    Call oStore.IBo_AddLoadFilter(CMP_EQUAL, FID_STORE_StoreNumber, m_oSession.CurrentEnterprise.IEnterprise_StoreNumber)
    Call oStore.IBo_AddLoadField(FID_STORE_AddressLine1)
    Call oStore.IBo_AddLoadField(FID_STORE_AddressLine2)
    Call oStore.IBo_AddLoadField(FID_STORE_AddressLine3)
    Call oStore.IBo_AddLoadField(FID_STORE_AddressLine4)
    Call oStore.IBo_AddLoadField(FID_STORE_PostCode)
    Call oStore.IBo_LoadMatches
    strHeader = strHeader & Left$(oStore.AddressLine1 & Space$(30), 30)
    strHeader = strHeader & Left$(oStore.AddressLine2 & Space$(30), 30)
    strHeader = strHeader & Left$(oStore.AddressLine3 & Space$(30), 30)
    strHeader = strHeader & Left$(oStore.AddressLine4 & Space$(30), 30)
    strHeader = strHeader & Space$(30) & Left$(oStore.PostCode & Space$(30), 30)
    strHeader = strHeader & "000000"
    strHeader = strHeader & Left$(Replace(mNarrative, vbCrLf, vbNullString) & Space$(121), 121) & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
    
    'Build file name to save data into
    strFilename = strFilename & m_oSession.GetParameter(PRM_EDIPREFIX) & strPrefixName & mOrderNumber & "." & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
    
    Call DebugMsg(MODULE_NAME, "CreateFile", endlDebug, "PO EDI File=" & strFilename)
    Set tsOrder = oFSO.CreateTextFile(strFilename, True)
    Call tsOrder.WriteLine(strHeader)
    
    Set oItem = m_oSession.Database.CreateBusinessObject(CLASSID_INVENTORY)
    Call oItem.IBo_AddLoadField(FID_INVENTORY_Description)
    For lngLineNo = 1 To Lines.Count Step 1
        Call oItem.IBo_ClearLoadFilter
        Call oItem.IBo_AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, mcolLines(CLng(lngLineNo)).PartCode)
        Call oItem.IBo_LoadMatches
        strLine = mcolLines(CLng(lngLineNo)).PartCode & "       " & Left$(oItem.Description & Space$(30), 30) & Format$(mcolLines(CLng(lngLineNo)).OrderQuantity, "000000")
'        strLine = mcolLines(CLng(lngLineNo)).PartCode & mcolLines(CLng(lngLineNo)).Description & mcolLines(CLng(lngLineNo)).OrderQuantity
        Call tsOrder.WriteLine(strLine)
    Next lngLineNo
    Set oItem = Nothing
    
    strTrailer = "TR"
    Call tsOrder.WriteLine(strTrailer)
    
    Call tsOrder.Close
    
    CreateEDIFile = True
    
    Exit Function
    
Bad_CreateFile:

    CreateEDIFile = False
    Call Err.Raise(Err.Number, Err.Source, Err.Description)
    Resume Next
    
End Function



Private Sub UpdateCommNumber(ByVal strCommNumber As String)

Dim oRow        As IRow
Dim oGField     As CFieldGroup

'    If strDRLKey <> mDocNo Then
'        Call IBo_ClearLoadFilter
'        Call IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTEHEADER_DocNo, strDRLKey)
'        Call IBo_AddLoadField(FID_DELNOTEHEADER_DocNo)
'        Call IBo_AddLoadField(FID_DELNOTEHEADER_Comm)
'        Call IBo_LoadMatches
'    End If
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    ' Identify row by the key
    Call oRow.Add(GetField(FID_PURCHASEORDER_Key))
    
    Set oGField = GetField(FID_PURCHASEORDER_CommNumber)
    ' and add to the row
    Call oRow.Add(oGField)
    
    mCommNumber = strCommNumber
    
    Call m_oSession.Database.SavePartialBo(Me, oRow)

End Sub


Private Function Save(eSave As enSaveType) As Boolean
' Save all properties to the database

Dim lLineNo     As Long
Dim oField      As IField
Dim oSysNum     As cSystemNumbers
Dim colNewLines As Collection
Dim blnUnPark   As Boolean
Dim blnComplete As Boolean
Dim oPurNarr    As cPurHdrNarrative
    
    Save = False
    
    If IsValid() Then
        
        If (blnParkOrder = False) And (LenB(mOrderNumber) = 0) And (eSave <> SaveTypeDelete) Then
            'Get parked order being saved then delete all flags
            If LenB(Me.ReleaseNumber) = 0 Then
                mReleaseNumber = "00"
                blnUnPark = True
            End If
            'Get Next Purchase Order Number
            Set oSysNum = m_oSession.Database.CreateBusinessObject(CLASSID_SYSTEMNO)
            mOrderNumber = oSysNum.GetNewPurchaseOrderNumber
            Set oSysNum = Nothing
        End If
        If LenB(mTimeCreated) = 0 Then mTimeCreated = Format$(Time, "HHNNSS")
        If (blnParkOrder = True) And (eSave = SaveTypeIfExists) Then blnUnPark = True
        
        Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Saving-" & mOrderNumber)
        Save = m_oSession.Database.SaveBo(eSave, Me)
        If Not Save Then
            Debug.Assert False
        Else
            If eSave <> SaveTypeDelete Then
                If mcolLines Is Nothing Then
                    Debug.Assert False
                    ' I guess we should rollback here?
    '                Save = False
                Else
                    If blnUnPark Then
                        'if order exists (parked) then delete old lines and insert new lines
                        Set colNewLines = mcolLines
                        'Get existing lines and delete
                        Call RetrieveLines(True)
                        For lLineNo = 1 To mcolLines.Count Step 1
                            Call mcolLines(CLng(lLineNo)).IBo_Delete
                        Next lLineNo
                        'restore lines to save
                        Set mcolLines = colNewLines
                    End If
                    If (eSave = SaveTypeIfNew) Or (blnUnPark = True) Then
                        ' All Ok, so insert the lines
                        For lLineNo = 1 To mcolLines.Count Step 1
                            mcolLines(CLng(lLineNo)).PurchaseOrderNo = Key
                            Call mcolLines(CLng(lLineNo)).IBo_SaveIfNew
                        Next lLineNo
                    Else
                        'Update existing lines (usually from deliveries)
                        blnComplete = True
                        For lLineNo = 1 To mcolLines.Count Step 1
                            Call mcolLines(CLng(lLineNo)).IBo_SaveIfExists
                            If mcolLines(CLng(lLineNo)).Complete = False Then blnComplete = False
                        Next lLineNo
                        'if lines outstanding then raise as back-order
                        mReceivedAll = blnComplete
                        If blnComplete = True Then mCompletedDate = Now()
                    End If
                End If 'valid purchase order lines
                If eSave = SaveTypeIfNew Then
                    If LenB(mNarrative) <> 0 Then 'if narrative captured then call sub BO to save
                        Set oPurNarr = m_oSession.Database.CreateBusinessObject(CLASSID_PURHDRNARRATIVE)
                        oPurNarr.OrderID = mKey
                        If InStr(mNarrative, vbCrLf) > 0 Then 'split narrative to 2 lines
                            If InStr(mNarrative, vbCrLf) > 1 Then
                                oPurNarr.TextLine1 = Left$(mNarrative, InStr(mNarrative, vbCrLf) - 1)
                            End If
                            oPurNarr.TextLine2 = mID$(mNarrative, InStr(mNarrative, vbCrLf) + 2)
                        Else
                            oPurNarr.TextLine1 = mNarrative
                            oPurNarr.TextLine2 = vbNullString
                        End If 'splitting up line
                        oPurNarr.StoreNumber = m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
                        Call oPurNarr.IBo_SaveIfNew
                        Set oPurNarr = Nothing
                    End If 'narrative has been entered
                End If 'saving new so insert narrative if captured

                If m_oSupplier Is Nothing Then Set m_oSupplier = m_oSession.Database.CreateBusinessObject(CLASSID_SUPPLIER)
                If (Not blnParkOrder) Then Call m_oSupplier.RecordPurchaseOrder(mSupplierNo, mOrderDate, mValue)
            End If 'Not delete
        End If
    Else
        Debug.Print "Purchase order not saved, IsValid() = False."
    End If

End Function

Private Function Delete() As Boolean

Dim lngLineNo As Long
    
    Delete = False
    If LenB(mOrderNumber) = 0 Then 'delete parked orders only
        If mcolLines Is Nothing Then Call RetrieveLines(True)
        For lngLineNo = 1 To mcolLines.Count Step 1
            Call mcolLines(CLng(lngLineNo)).IBo_Delete
        Next lngLineNo
        Call Save(SaveTypeDelete)
    End If

End Function

Private Function IsValid() As Boolean
    IsValid = True
    If mcolLines Is Nothing Then
        ' We must have some line items otherwise we don't have a Purchase Order.
        Debug.Assert False
        IsValid = False
    End If
End Function


Private Function GetAllFieldsAsRow() As IRow
' Returns a CRow object containing one field object for each property.
    
Dim oRow    As IRow
Dim nFid    As Long
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    For nFid = (CLASSID_PURCHASEORDER * &H10000) + 1 To FID_PURCHASEORDER_END_OF_STATIC Step 1
        Call oRow.Add(GetField(nFid))
    Next nFid
    Set GetAllFieldsAsRow = oRow

End Function

'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadFilter()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up any selection criteria before
'*              calling the IBo_Load method.  This appends the selection criteria to the
'*              oRowSel object which is used by the IBo_Load method.
'**********************************************************************************************
'* Parameters:
'*In/Out:Comparator Long. - Comparison Type - see modBO.bas
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'*In/Out:Value  Variant. - Value that Field will be compared to
'**********************************************************************************************
'* Returns:  Boolean - True if Valid FieldID and successful
'**********************************************************************************************
'* History:
'* 08/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function IBo_AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean
    IBo_AddLoadFilter = AddLoadFilter(Comparator, FieldID, Value)
End Function

Public Function AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean

Dim oField As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadFilter"

    'Create field for storing Key into
    Set oField = GetField(FieldID)
    If oField Is Nothing Then Exit Function
    oField.ValueAsVariant = Value
    
    'Add field to Row selector
    If moRowSel Is Nothing Then Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moRowSel.AddSelection(Comparator, oField)
    AddLoadFilter = True

End Function 'AddLoadFilter

'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadField()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up all fields that must be returned
'*              when using the LoadMatches method.  This appends the field to the oFieldRow
'*              object which is used by the IBo_LoadMatches method, if it is populated.
'**********************************************************************************************
'* Parameters:
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'**********************************************************************************************
'* History:
'* 09/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub IBo_AddLoadField(FieldID As Long)
    AddLoadField FieldID
End Sub

Public Sub AddLoadField(FieldID As Long)

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadField"
    
    'Add field to Row selector
    If moLoadRow Is Nothing Then Set moLoadRow = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moLoadRow.AddSelectAll(FieldID)

End Sub      'AddLoadField

Public Sub IBo_ClearLoadFilter()
    ClearLoadFilter
End Sub

Public Sub ClearLoadFilter()

    Set moRowSel = Nothing

End Sub

Public Sub IBo_ClearLoadField()
    ClearLoadField
End Sub

Public Sub ClearLoadField()

    Set moLoadRow = Nothing

End Sub

Public Function IBo_LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection
    Set IBo_LoadMatches = LoadMatches(oReturnRow)
End Function

Public Function LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection

' Load up all properties from the database
Dim oView       As IView
Dim colBO       As Collection
Dim oBO         As ISysBo
Dim lBONo       As Long
Dim oLoadFields As IRowSelector
    
    Set colBO = New Collection
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    Set oLoadFields = moRowSel
    If oLoadFields Is Nothing Then Set oLoadFields = m_oSession.Root.CreateUtilityObject("CRowSelector")
    
    If oReturnRow Is Nothing Then
        If moLoadRow Is Nothing Then
            Call oLoadFields.Merge(GetSelectAllRow)
        Else
            Call oLoadFields.Merge(moLoadRow) ' add in the specified field
        End If
    Else
        Call oLoadFields.Merge(oReturnRow) ' add in the specified field
    End If
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(oLoadFields)
    If Not (oView Is Nothing) Then
        For lBONo = 1 To oView.Count Step 1
            Set oBO = m_oSession.Database.CreateBusinessObject(IBo_ClassId)
            Call oBO.LoadFromRow(oView.Row(CLng(lBONo)))
            If lBONo = 1 Then Call LoadFromRow(oView.Row(CLng(1)))
            Call colBO.Add(oBO)
        Next lBONo
    End If
    
    Set LoadMatches = colBO

End Function

'##ModelId=3DEF32240046
Public Function Despatch() As Boolean
' A Purchase Order cannot be recognised until it has been received by the supplier.
' This method starts the process of sending the order to the supplier, using an appropriate
' route.  The routes may be in descending order of preference: email, fax, snail mail.
' For each route, the process may have several phases, such as:
'   * logically despatched, but pending physical despatch (in mail, fax or print queue)
'   * physical despatch, intermediate stage (printed but not faxed or handed to the
'     Post Office, or handed to the Post Office but in transit.
'   * despatch complete, unverified (assumed received after an appropriate time period)
'   * despatch confirmed (automatic aknowledgement from recipient or manually entered)
' We map these to four despatch status', not despatched, despatched - in transit, despatched
' - completion assumed, despatched - completion confirmed.
' We return boolean indicating if the Despatch was successful.
Dim eDespatchType As enDespatchType
Dim oMailer       As Object
    
    If DespatchStatus = DespatchStatusNotDespatched Then
        ' Not despatched yet, so lets try doing it
        Select Case (eDespatchType)
        Case DespatchTypeEmail:
            Debug.Assert False
            'Set oMailer = New Mailer
            oMailer.FakeIt
            oMailer.Send "223.223.223.206", "OasysEE Despatcher", "mauricem@ctsuk.co.uk", _
                "Purchase Order #" & Key & "  for supplier " & SupplierNo, "Please supply the following items:" & vbCrLf & _
                "    Nothing just yet thanks.", vbNullString
            Set oMailer = Nothing
        Case DespatchTypeFax:
            Debug.Assert False
        Case Else:
            Debug.Assert False
        End Select
                
        DespatchStatus = DespatchStatusInTransit
        Despatch = True
    Else
        ' Currently we are not allowing users to despatch a second time.
        ' If they want to do this, they first need to reset the PO to Not despatched
        Debug.Assert False
    End If
End Function

